        .MODEL small
        .STACK 100h

         ; ===============================
         ; Program k zadani ulohy c.1
         ; ===============================

        .DATA

tabulka  dw     1000100000100010b       ; VZ=Cervena       SJ=Zelena
         dw     1000100001000100b       ; VZ=Cervena       SJ=zluta
	 dw     1000100010001000b	; VZ=Cervena       SJ=Cervena
	 dw     1100110010001000b	; VZ=Cervena+Zluta SJ=Cervena
         dw     0010001010001000b       ; VZ=Zelena        SJ=Cernena
         dw     0100010010001000b       ; VZ=Zluta         SJ=Cervena
	 dw     1000100010001000b	; VZ=Cervena       SJ=Cervena
	 dw     1000100011001100b	; VZ=Cervena       SJ=Cervena+Zluta
         ;      CzZOCzZOCzZOCzZO          (O=Odboceni_doprava)
         ;      < Z>< V>< S>< J>

nabeh    dw     1000100000100010b
         dw     1000100001000100b
         dw     1000100010001000b	; vsude cervena 

noc      dw     0100010001000100b       ; signaly pro nocni provoz
         dw     0000000000000000b	; - blikajici zluta

chodci   db     01011010b		; VZ=Zelena    SJ=Cervena
	 db     0
         db     10101010b		; vsude cervena
	 db     0
         db     10101010b		; vsude cervena
	 db     0
         db     10101010b		; vsude cervena
	 db     0
         db     10100101b		; VZ=Cervena   SJ=Zelena
	 db     0
         db     10101010b		; vsude cervena
 	 db     0
         db     10101010b		; vsude cervena
	 db     0
         db     10101010b		; vsude cervena
 	 db     0
	 ;      CzCzCzCz
	 ;      ZZVVSSJJ

auta     db     0			; pocet aut na severu
	 db     0			; jihu
         db     0			; vychode
	 db     0			; a zapade

vnoci    db     0                       ; nocni provoz?
doba     db     1			; delka cekani vnejsi smycky
 
Text     db     'Semafor 1.                                                                      '
	 db     '                                                                                '
	 db     'Ovladani a popis:                                                               '
	 db     'Program simuluje provoz na krizovatce. Tlacitkama se pridavaji auta do jednotlivych smeru. K jejich poctu je pak prihlednuto pri rozhodovani o delce intervalu zelene v jednotlivych smerech.',0Dh,0Ah
	 db     '                                                                                '
	 db     'prepinac 4 - plynuly prechod do nocniho rezimu                                  '
	 db     'prepinac 3 - vypnuti programu                                                   '
	 db     '                                                                                $',0Dh,0Ah

	.CODE

start:   mov  ax,@DATA
	 mov  ds,ax
	 mov  dx,offset Text
	 mov  ah,09h			; Popis a ovladani
	 int  21h
	 mov  ax,0B8D2h			; Pro primy vystup na obrazovku
	 mov  es,ax
	 mov byte ptr ES:[00],'j'
	 mov byte ptr ES:[02],'i'
	 mov byte ptr ES:[04],'h'
	 mov byte ptr ES:[06],':'

	 mov byte ptr ES:[0A0h],'s'
	 mov byte ptr ES:[0A2h],'e'
	 mov byte ptr ES:[0A4h],'v'
	 mov byte ptr ES:[0A6h],'e'
	 mov byte ptr ES:[0A8h],'r'
	 mov byte ptr ES:[0AAh],':'

	 mov byte ptr ES:[0140h],'v'
	 mov byte ptr ES:[0142h],'y'
	 mov byte ptr ES:[0144h],'c'
	 mov byte ptr ES:[0146h],'h'
	 mov byte ptr ES:[0148h],'o'
	 mov byte ptr ES:[014Ah],'d'
	 mov byte ptr ES:[014Ch],':'

	 mov byte ptr ES:[01E0h],'z'
	 mov byte ptr ES:[01E2h],'a'
	 mov byte ptr ES:[01E4h],'p'
	 mov byte ptr ES:[01E6h],'a'
	 mov byte ptr ES:[01E8h],'d'
	 mov byte ptr ES:[01EAh],':'

start2:  mov  si,0                      ; Zacatek hlavniho programu
	 cmp  vnoci,0			; deni provoz?
	 jz   dprovoz
	 cmp  vnoci,2 			; nocni provoz?
	 jz   nprovoz

nnabeh:  mov  ax,nabeh[si]		; Nabeh na nocni provoz
         call ssend                     ; Odeslani na semafor pro vozidla
	 mov  al,chodci[si]             ; Nacteni slova z tabulky pro chodce
	 call csend			; Odeslani na semafor pro chodce
	 mov  doba,1
	 cmp  si,0			; zelena? - delsi cekani
	 jnz  jed
	 mov  doba,3  
jed:     call delay                     ; Cekani
         add  si,2                      ; Uprava indexregistru
         cmp  si,6                      ; Uz jsme odeslali vsechny 3 slova?
         jnz  nnabeh                    ; ... ne, nacteme dalsi
	 mov  vnoci,2			; nastav plny nocni provoz
	 mov  al,00000000b
	 call csend			; vypni semafor chodcu

	 mov  si,0
nprovoz: mov  ax,noc[si]                ; Nacteni slova z tabulky pro nocni provoz
         call ssend                     ; Odeslani na semafor pro vozidla
	 mov  doba,1
         call delay                     ; Cekani
         add  si,2                      ; Uprava indexregistru
         cmp  si,4                      ; Uz jsme odeslali obe slova?
         jnz  nprovoz                   ; ... ne, nacteme dalsi
         jmp  start2                    ; ... ano, zpet na zacatek

dprovoz: mov  ax,tabulka[si]            ; Nacteni slova z tabulky pro denni provoz
         call ssend                     ; Odeslani na semafor pro vozidla
	 mov  al,chodci[si]             ; Nacteni slova z tabulky pro chodce
	 call csend			; Odeslani na semafor pro chodce
	 call delka			; nastav dobu trvani pausy
         call delay                     ; Cekani
dal:     add  si,2                      ; Uprava indexregistru
         cmp  si,16                     ; Uz jsme odeslali vsech 6 slov?
         jnz  dprovoz                   ; ... ne, nacteme dalsi
         jmp  start2                    ; ... ano, zpet na zacatek



delay:   push ax                        ; Aktivni cekani
	 push dx
	 push cx
	 mov  dl,doba
pruj:	 cmp  dl,3
	 jc   nepoc
	 call delka
	 mov  dl,doba
nepoc:	 mov  cx,0800h
vnejsi:  mov  ax,0ffffh
vnitrni: dec  ax
         jnz  vnitrni

	 mov  ax,0B8D2h			; Pro primy vystup na obrazovku
	 mov  es,ax
	 mov  ah,auta[1]		; Vypis pocet aut
	 add  ah,30h
	 mov byte ptr ES:[0Eh],ah
	 mov  ah,auta[0]
	 add  ah,30h
	 mov byte ptr ES:[0AEh],ah
	 mov  ah,auta[2]
	 add  ah,30h
	 mov byte ptr ES:[014Eh],ah
	 mov  ah,auta[3]
	 add  ah,30h
	 mov byte ptr ES:[01EEh],ah

         loop vnejsi

	 call tlac			; zjisti stav tlacitek
	 mov  cx,0900h
vne2:    mov  ax,0ffffh
vni2:    dec  ax
         jnz  vni2
 	 loop vne2

	 call tlac           		; zjisti stav tlacitek
	 call prujezd			; projed auto
	 dec  dl
	 jnz  pruj
	 pop  cx
	 pop  dx
         pop  ax
         ret


ssend:                                  ; Vyslani 16-ti bitove hodnoty z AX
         mov  dx,378h                   ; Adresa vystupni brany LPT1:
         mov  cx,10h                    ; Citac pruchodu
         not  ax                        ; Negace AX (0=nesviti, 1=sviti)
scykl:   ror  ax,1			; Vlastni cykl pro vyslani obsahu AX
         jc   sjedna			; Bit k odeslani = 1?
         call ssend0                    ; ... ne, vysli 0
         jmp  sskip                    
sjedna:  call ssend1                    ; ... ano, vysli 1
sskip:   loop scykl                     ; a pokracuj s dalsi rotaci AX
         ret


csend:                                  ; Vyslani 16-ti bitove hodnoty z AX
         mov  dx,378h                   ; Adresa vystupni brany LPT1:
         mov  cx,8h                     ; Citac pruchodu
         not  al                        ; Negace AX (0=nesviti, 1=sviti)
ccykl:   ror  al,1			; Vlastni cykl pro vyslani obsahu AX
         jc   cjedna			; Bit k odeslani = 1?
         call csend0                    ; ... ne, vysli 0
         jmp  cskip                    
cjedna:  call csend1                    ; ... ano, vysli 1
cskip:   loop ccykl                     ; a pokracuj s dalsi rotaci AX
         ret


ssend0:  push ax                        ; Zapis hodnoty 0 do pos. registru semaforu
         mov  al,0                      ; Data=0, hodiny=0
         out  dx,al
         mov  al,2                      ; Data=0, hodiny=1 (nabezna hrana)
         out  dx,al
         pop  ax
         ret


ssend1:  push ax                        ; Zapis hodnoty 1 do pos. registru semaforu
         mov  al,1                      ; Data=1, hodiny=0
         out  dx,al
         mov  al,3                      ; Data=1, hodiny=1 (nabezna hrana)
         out  dx,al
         pop  ax
         ret


csend0:  push ax                        ; Zapis hodnoty 0 do pos. registru chodcu
         mov  al,0                      ; Data=0, hodiny=0
         out  dx,al
         mov  al,8                      ; Data=0, hodiny=1 (nabezna hrana)
         out  dx,al
         pop  ax
         ret


csend1:  push ax                        ; Zapis hodnoty 1 do pos. registru chodcu
         mov  al,4                      ; Data=1, hodiny=0
         out  dx,al
         mov  al,12                     ; Data=1, hodiny=1 (nabezna hrana)
         out  dx,al
         pop  ax
         ret


tlac:	 push ax
	 push dx
	 mov  dx,378h
	 mov  ax,04h
	 out  dx,ax			; precti stav tlacitek a vypinacu
	 inc  dx
	 in   al,dx
	 ror  al,1
	 ror  al,1
	 ror  al,1
	 ror  al,1
         jc   t2			; tlacitko na jihu
         inc  auta[1]
t2:	 shr  al,1
         jc   t3			; tlacitko na severu
         inc  auta[0]
t3:	 shr  al,1
         jc   t4			; tlacitko na vychode
         inc  auta[2]
t4:	 shr  al,1
         jc   vyp1			; tlacitko na zapade
         inc  auta[3]
vyp1:    mov  dx,378h
	 mov  ax,01h
	 out  dx,ax
	 inc  dx
	 in   al,dx
	 push ax
	 and  al,8
	 cmp  al,8
	 jnc  nenoc
	 cmp  vnoci,2
	 jnc  vyp2 
	 mov  vnoci,1			; 1. vypinac nahore - nocni provoz
	 jmp  vyp2
nenoc:	 mov  vnoci,0			; 1. vypinac dole - denni provoz
vyp2:    pop  ax
	 and  al,10h			; 2. vypinac dole?
         cmp  al,10h
         jnc  zpet
         mov  ax,4C00h			; ano? -> skonci
	 int  21h
zpet:    pop  dx
         pop  ax
	 ret


delka:   push ax
	 push bx
	 cmp  si,11
	 jnc  nula
	 cmp  si,0
	 jz   dobre
	 cmp  si,7
	 jc   nula			; Urci smer otevreni VZ/SJ
	 mov  al,auta[2]
	 mov  bl,auta[3]
	 cmp  al,bl			; vic aut na vychode nebo na zapade?
	 jc   zap
	 mov  doba,al			; doba = pocet aut na vychode
	 jmp  pryc
zap:     mov  doba,bl			; doba = pocet aut na zapade
	 jmp  pryc
dobre:   mov  al,auta[0]
	 mov  bl,auta[1]
	 cmp  al,bl			; vic aut na jihu nebo severu?
	 jc   jih
	 mov  doba,al			; doba = pocet aut na severu
	 jmp  pryc
jih:	 mov  doba,bl			; doba = pocet aut na jihu
	 jmp  pryc
nula:    mov  doba,1			; rychla zmena
pryc:    cmp  doba,10
	 jc   oo
	 mov  doba,10
oo:	 cmp  doba,3
	 jnc  oi
	 mov  doba,3
oi:	 pop  bx
	 pop  ax
	 ret


prujezd: push ax
	 push bx
	 mov  bx,0			; pro diody
	 cmp  vnoci,2
	 jz   vyskoc			; nocni rezim?
	 cmp  si,11
	 jnc  vyskoc			; neni zelena
	 cmp  si,0
	 jz   a0			; otevren SJ
	 cmp  si,7
	 jc   vyskoc			; neni zelena
	 cmp  auta[2],1
	 jc   a3
	 dec  auta[2]			; sniz auta na vychode
	 or   bx,4
a3:	 cmp  auta[3],1
	 jc   zavri
	 dec  auta[3]			; sniz auta na zapade
	 or   bx,8
	 jmp  zavri

a0:      cmp  auta[0],1
	 jc   a1
	 dec  auta[0]			; sniz auta na severu
	 or   bx,1
a1:	 cmp  auta[1],1
	 jc   zavri
	 dec  auta[1]			; sniz auta na jihu
	 or   bx,2

zavri:	 push cx
	 push dx
	 mov  ax,bx 			; vysli na diody
	 call dsend
	 mov  cx,0ffffh
pauza:   loop pauza			; pauza
	 mov  ax,0
	 call dsend			; zhasni diody
	 pop  dx
	 pop  cx
vyskoc:	 pop  bx
	 pop  ax
 	 ret


dsend:   mov  dx,378h                   ; Adresa vystupni brany LPT1:
         mov  cx,4h                     ; Citac pruchodu
         not  al                        ; Negace AX (0=nesviti, 1=sviti)
dcykl:   ror  al,1			; Vlastni cykl pro vyslani obsahu AX
         jc   djedna			; Bit k odeslani = 1?
         call dsend0                    ; ... ne, vysli 0
         jmp  dskip                    
djedna:  call dsend1                    ; ... ano, vysli 1
dskip:   loop dcykl                     ; a pokracuj s dalsi rotaci AX


dsend0:  push ax                        ; Zapis hodnoty 0 do pos. registru semaforu
         mov  al,0                      ; Data=0, hodiny=0
         out  dx,al
         mov  al,20h                    ; Data=0, hodiny=1 (nabezna hrana)
         out  dx,al
         pop  ax
         ret


dsend1:  push ax                        ; Zapis hodnoty 1 do pos. registru semaforu
         mov  al,10h                    ; Data=1, hodiny=0
         out  dx,al
         mov  al,30h                    ; Data=1, hodiny=1 (nabezna hrana)
         out  dx,al
         pop  ax
         ret


         END start